{$f+}
unit appstr;

interface

{ 㤠 譨 ࠧ⥫ ࠢ  ᫥ }
procedure clearline(var line:string);

{  ॣ  ப }
procedure upcasestr(var line:string);

{  ॣ }
procedure downcasestr(var line:string);

{  ᫮  ஬ number  ப line }
function getword(line:string;number:byte):string;

{ ⢮ ᨬ  ப }
function countchar(line:string;ch:char):byte;

{ ᮧ ப  ᨬ }
function makestr(count:byte;symbol:char):string;

{ byte -  ⥪⮢ ।⠢ (HEX) }
function byte2hexstr(value:byte):string;

{ ⮦ ᠬ   Integer }
function integer2hexstr(value:integer):string;

{ 頥 ᨬ쭮 ।⠢ ᫠ value }
{  訡 頥 -1 ( value = -1  ࠢ쭮 ࠡ⠥) }
function val2str(value:longint):string;

{ ⮦ ᠬ   pos ⮫쪮  稭   ப }
function endpos(substr:string;line:string):byte;

implementation

uses appchar;

procedure clearline(var line:string);
begin
     while isitspace(line[1]) and (length(line)>0) do delete(line,1,1);
     while isitspace(line[length(line)]) and (length(line)>0) do
           delete(line,length(line),1);
end;

procedure upcasestr(var line:string);
var
   index                        : byte;
begin
     for index:=1 to length(line) do line[index]:=upcase(line[index]);
end;

procedure downcasestr(var line:string);
var
   index                        : byte;
begin
     for index:=1 to length(line) do line[index]:=downcase(line[index]);
end;

function getword(line:string;number:byte):string;
var
   tmpline,return               : string;
   tmpnumber,long               : byte;
begin
     tmpline:=line;
     tmpnumber:=0;
     clearline(tmpline);
     repeat
           for long:=1 to length(tmpline) do
               if isitspace(tmpline[long]) then break;
           return:=copy(tmpline,1,long);
           delete(tmpline,1,long);
           clearline(tmpline);
           inc(tmpnumber);
     until (tmpnumber=number) or (tmpline='');
     if tmpnumber<>number then return:='';
     clearline(return);
     getword:=return;
end;

function countchar(line:string;ch:char):byte;
var
   count                        : byte;
   tmp                          : string;
begin
     tmp:=line;
     count:=0;
     while pos(ch,line)<>0 do
           begin
                inc(count);
                delete(line,pos(ch,line),1);
           end;
     countchar:=count;
end;

function makestr(count:byte;symbol:char):string;
var
   tmp          : string;
begin
     tmp:='';
     while count<>0 do
           begin
                tmp:=tmp+symbol;
                dec(count);
           end;
     makestr:=tmp;
end;

function byte2hexstr(value:byte):string;
var
   symbol               : array[1..2] of byte;
   index                : byte;
begin
     symbol[1]:=(value - (value mod 16)) div 16;
     symbol[2]:=value mod 16;
     for index:=1 to 2 do
         begin
              symbol[index]:=symbol[index]+48;
              if symbol[index]>ord('9') then
                 symbol[index]:=symbol[index]+7;
         end;
     byte2hexstr:=chr(symbol[1])+chr(symbol[2]);
end;

function val2str(value:longint):string;
var
   tmp                  : string;
begin
     str(value,tmp);
     val2str:=tmp;
end;

function integer2hexstr(value:integer):string;
var
   index        : byte;
   result       : string;
   symbol       : array[1..4] of byte;
begin
     result:='';
     symbol[4]:=value mod 16;
     symbol[3]:=((value - symbol[4]) div 16) mod 16;
     symbol[2]:=((value - symbol[3]) div 256) mod 16;
     symbol[1]:=((value - symbol[2]) div 4096) mod 16;
     for index:=1 to 4 do
         begin
              symbol[index]:=symbol[index]+48;
              if symbol[index]>ord('9') then
                 symbol[index]:=symbol[index]+7;
              result:=result+chr(symbol[index]);
         end;
     integer2hexstr:=result;
end;

function endpos(substr:string;line:string):byte;
var
   index        : byte;
begin
     index:=length(line);
     repeat
           if copy(line,index,length(substr))=substr then break;
           dec(index);
     until index=0;
     endpos:=index;
end;


end.

